subroutine param_gen(gen_par)
  use genrev3d_types
  use sep

  implicit none
  type (genrev3d_param_type) gen_par

  !integer, intrinsic ::  mp_numthreads
!  integer ::  mp_numthreads
  integer ::  omp_get_num_threads
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout

  integer n_threads_env

  call from_param('comp_domain',gen_par%comp_domain,trim(gen_par%comp_domain))

  call from_param('oper_type',gen_par%oper_type,trim(gen_par%oper_type))

  call from_param('domain_range',gen_par%domain_range,trim(gen_par%domain_range))
  call from_param('verb',gen_par%verb,gen_par%verb)
  call from_param('debug1',gen_par%debug1,gen_par%debug1)
  call from_param('debug2',gen_par%debug2,gen_par%debug2)

  call from_param('timers_on',gen_par%timers_on,gen_par%timers_on)
  call from_param('image_zero_offset',gen_par%image_zero_offset,gen_par%image_zero_offset)
  call from_param('surf_offset_cig',gen_par%surf_offset_cig,gen_par%surf_offset_cig)


  call from_param('first_adj',gen_par%first_adj,gen_par%first_adj)
  call from_param('first_add',gen_par%first_add,gen_par%first_add)

  call from_param('check_stability',gen_par%check_stability,gen_par%check_stability)
  call from_param('tau_domain',gen_par%tau_domain,gen_par%tau_domain)
  call from_param('layered_mig_vel',gen_par%layered_mig_vel,gen_par%layered_mig_vel)
  call from_param('skip_source_prop',gen_par%skip_source_prop,gen_par%skip_source_prop)

  call from_param('n_threads',gen_par%n_threads,gen_par%n_threads)
  call from_param('max_memory',gen_par%max_memory,gen_par%max_memory)

  call from_param('n_data_dim',gen_par%n_data_dim,gen_par%n_data_dim)
  call from_param('slow_const',gen_par%slow_const,gen_par%slow_const)

  call from_param('sou_depth',gen_par%sou_depth,gen_par%sou_depth)
  call from_param('rec_depth',gen_par%rec_depth,gen_par%rec_depth)



  ! checking parameters
!$omp parallel
!call omp_set_num_threads(2)
  n_threads_env=omp_get_num_threads()
!$omp end parallel
  if(gen_par%n_threads == n_threads_init) then
     gen_par%n_threads=n_threads_env
  else
     if(n_threads_env > gen_par%n_threads) then
        call omp_set_num_threads(gen_par%n_threads)
        write(0,*)'WARNING: overwriting environment variable'
        write(0,*)'gen_par-n_threads=',gen_par%n_threads
     end if
     if(n_threads_env < gen_par%n_threads) then
        write(0,*)'gen_par-n_threads=',gen_par%n_threads
        write(0,*)'OMP_NUM_THREADS=',n_threads_env
        call seperr('ERROR: Asked for more threads than the environment variable allows')
     end if
  end if
  if(gen_par%debug1)write(0,*)'gen_par-n_threads=',gen_par%n_threads
  call to_history('n_threads',gen_par%n_threads)

  !converting comp_domain to standard strings
  select case (gen_par%comp_domain(1:4))
  case ('shot')
     gen_par%comp_domain(1:4)='shot'
  case ('midp')
     gen_par%comp_domain(1:4)='midp'
  case default
     write(0,*)'gen_par-comp_domain=',trim(gen_par%comp_domain)
     call seperr('Not supported comp_domain')
  end select


  !coverting domain_range to standard strings
  select case (gen_par%domain_range(1:9))
  case ('data_imag')
     gen_par%domain_range(1:9)='data_imag'
  case ('data_wave')
     gen_par%domain_range(1:9)='data_wave'
  case default
     write(0,*)'gen_par-domain_range=',trim(gen_par%domain_range)
     call seperr('Not supported domain_range')
  end select


  return
end subroutine param_gen


subroutine param_data(gen_par,data_par)
  use genrev3d_types
  use data_types
  use sep

  implicit none

  type (genrev3d_param_type) gen_par
  type (data_param_type) data_par

  logical write_down_data,write_down_ddata
  character(len=128) :: tag_name
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout,auxinout
  integer ierr
  integer n1,n2,n3,n4,n5,esize
  real d1,d2,d3,d4,d5,o1,o2,o3,o4,o5

  data_par%esize=4

  call from_param('tag_data',data_par%tag,'Data')
  call from_param(trim(data_par%tag),tag_name,'Data not found')

  ! First deal with tag Data
  if(gen_par%domain_range(1:4) == 'data') then
     !{
     if (.not. gen_par%first_adj) then
        !{
        ierr=auxinout(trim(data_par%tag))
        data_par%file=DATA_OUTPUT

        if_comp_domain_data_1 : if (gen_par%comp_domain(1:4) == 'midp') then

          call from_param('n_t',data_par%n_t)
          call from_param('n_mx',data_par%n_mx)
          call from_param('n_my',data_par%n_my)
          call from_param('n_hx',data_par%n_hx)

          call from_param('d_t',data_par%d_t)
          call from_param('d_mx',data_par%d_mx)
          call from_param('d_my',data_par%d_my)
          call from_param('d_hx',data_par%d_hx)

          call from_param('t_0',data_par%t_0,0.)
          call from_param('mx_0',data_par%mx_0,0.)
          call from_param('my_0',data_par%my_0,0.)
          call from_param('hx_0',data_par%hx_0,0.)
  
          if(gen_par%n_data_dim >4) then 
             call from_param('n_hy',data_par%n_hy)
             call from_param('d_hy',data_par%d_hy)
             call from_param('hy_0',data_par%hy_0,0.)
          else
             data_par%n_hy=1
             data_par%d_hy=1.
          end if
  
          call to_history("esize",data_par%esize,trim(data_par%tag))
          call to_history("n1",data_par%n_mx,trim(data_par%tag))
          call to_history("n2",data_par%n_my,trim(data_par%tag))
          call to_history("n3",data_par%n_hx,trim(data_par%tag))
          call to_history("d1",data_par%d_mx,trim(data_par%tag))
          call to_history("d2",data_par%d_my,trim(data_par%tag))
          call to_history("d3",data_par%d_hx,trim(data_par%tag))
          call to_history("o1",data_par%mx_0,trim(data_par%tag))
          call to_history("o2",data_par%my_0,trim(data_par%tag))
          call to_history("o3",data_par%hx_0,trim(data_par%tag))
          if(gen_par%n_data_dim >4) then 
             call to_history("n4",data_par%n_hy,trim(data_par%tag))
             call to_history("n5",data_par%n_t,trim(data_par%tag))
             call to_history("o4",data_par%hy_0,trim(data_par%tag))
             call to_history("o5",data_par%t_0,trim(data_par%tag))
             call to_history("d4",data_par%d_hy,trim(data_par%tag))
             call to_history("d5",data_par%d_t,trim(data_par%tag))
          else
             call to_history("n4",data_par%n_t,trim(data_par%tag))
             call to_history("n5",data_par%n_hy,trim(data_par%tag))
             call to_history("o4",data_par%t_0,trim(data_par%tag))
             call to_history("o5",data_par%hy_0,trim(data_par%tag))
             call to_history("d4",data_par%d_t,trim(data_par%tag))
             call to_history("d5",data_par%d_hy,trim(data_par%tag))
          end if

       else if_comp_domain_data_1

          call from_param('n_t',data_par%n_t)
          call from_param('n_sx',data_par%n_sx)
          call from_param('n_sy',data_par%n_sy)
          call from_param('n_off_x',data_par%n_off_x)

          call from_param('d_t',data_par%d_t)
          call from_param('d_sx',data_par%d_sx)
          call from_param('d_sy',data_par%d_sy)
          call from_param('d_off_x',data_par%d_off_x)

          call from_param('t_0',data_par%t_0,0.)
          call from_param('sx_0',data_par%sx_0,0.)
          call from_param('sy_0',data_par%sy_0,0.)
          call from_param('off_x_0',data_par%off_x_0,0.)
  
          if(gen_par%n_data_dim >4) then 
             call from_param('n_off_y',data_par%n_off_y)
             call from_param('d_off_y',data_par%d_off_y)
             call from_param('off_y_0',data_par%off_y_0,0.)
          else
             data_par%n_off_y=1
             call from_param('d_off_y',data_par%d_off_y,1.)
             call from_param('off_y_0',data_par%off_y_0,0.)
          end if
  
          call to_history("esize",data_par%esize,trim(data_par%tag))
          call to_history("n1",data_par%n_off_x,trim(data_par%tag))
          call to_history("d1",data_par%d_off_x,trim(data_par%tag))
          call to_history("o1",data_par%off_x_0,trim(data_par%tag))

          if(gen_par%n_data_dim >4) then 
             call to_history("n2",data_par%n_off_y,trim(data_par%tag))
             call to_history("n3",data_par%n_t,trim(data_par%tag))
             call to_history("n4",data_par%n_sx,trim(data_par%tag))
             call to_history("n5",data_par%n_sy,trim(data_par%tag))

             call to_history("o2",data_par%off_y_0,trim(data_par%tag))
             call to_history("o3",data_par%t_0,trim(data_par%tag))
             call to_history("o4",data_par%sx_0,trim(data_par%tag))
             call to_history("o5",data_par%sy_0,trim(data_par%tag))

             call to_history("d2",data_par%d_off_y,trim(data_par%tag))
             call to_history("d3",data_par%d_t,trim(data_par%tag))
             call to_history("d4",data_par%d_sx,trim(data_par%tag))
             call to_history("n5",data_par%d_sy,trim(data_par%tag))
          else
             call to_history("n2",data_par%n_t,trim(data_par%tag))
             call to_history("n3",data_par%n_sx,trim(data_par%tag))
             call to_history("n4",data_par%n_sy,trim(data_par%tag))

             call to_history("d2",data_par%d_t,trim(data_par%tag))
             call to_history("d3",data_par%d_sx,trim(data_par%tag))
             call to_history("d4",data_par%d_sy,trim(data_par%tag))

             call to_history("o2",data_par%t_0,trim(data_par%tag))
             call to_history("o3",data_par%sx_0,trim(data_par%tag))
             call to_history("o4",data_par%sy_0,trim(data_par%tag))
          end if

       end if if_comp_domain_data_1
  
        !}
     else
        !{
         ierr=auxinout(trim(data_par%tag))
         data_par%file=DATA_INPUT

         call from_aux(trim(data_par%tag),"esize",esize)

         if_comp_domain_data_2 : if (gen_par%comp_domain(1:4) == 'midp') then

           call from_aux(trim(data_par%tag),"n1",data_par%n_mx)
           call to_history("From Data: n1",data_par%n_mx)
           call from_aux(trim(data_par%tag),"n2",data_par%n_my)
           call to_history("From Data: n2",data_par%n_my)
           call from_aux(trim(data_par%tag),"n3",data_par%n_hx)
           call to_history("From Data: n3",data_par%n_hx)
           call from_aux(trim(data_par%tag),"d1",data_par%d_mx)
           call to_history("From Data: d1",data_par%d_mx)
           call from_aux(trim(data_par%tag),"d2",data_par%d_my)
           call to_history("From Data: d2",data_par%d_my)
           call from_aux(trim(data_par%tag),"d3",data_par%d_hx)
           call to_history("From Data: d3",data_par%d_hx)
           call from_aux(trim(data_par%tag),"o1",data_par%mx_0,0.)
           call to_history("From Data: o1",data_par%mx_0)
           call from_aux(trim(data_par%tag),"o2",data_par%my_0,0.)
           call to_history("From Data: o2",data_par%my_0)
           call from_aux(trim(data_par%tag),"o3",data_par%hx_0,0.)
           call to_history("From Data: o3",data_par%hx_0)
           if(gen_par%n_data_dim >4) then 
              call from_aux(trim(data_par%tag),"n4",data_par%n_hy)
              call to_history("From Data: n4",data_par%n_hy)
              call from_aux(trim(data_par%tag),"n5",data_par%n_t)
              call to_history("From Data: n5",data_par%n_t)
              call from_aux(trim(data_par%tag),"d4",data_par%d_hy)
              call to_history("From Data: d4",data_par%d_hy)
              call from_aux(trim(data_par%tag),"d5",data_par%d_t)
              call to_history("From Data: d5",data_par%d_t)
              call from_aux(trim(data_par%tag),"o4",data_par%hy_0,0.)
              call to_history("From Data: o4",data_par%hy_0)
              call from_aux(trim(data_par%tag),"o5",data_par%t_0,0.)
              call to_history("From Data: o5",data_par%t_0)
           else
              call from_aux(trim(data_par%tag),"n4",data_par%n_t)
              call to_history("From Data: n4",data_par%n_t)
              call from_aux(trim(data_par%tag),"n5",data_par%n_hy,1)
              call to_history("From Data: n5",data_par%n_hy)
              call from_aux(trim(data_par%tag),"d4",data_par%d_t)
              call to_history("From Data: d4",data_par%d_t)
              call from_aux(trim(data_par%tag),"d5",data_par%d_hy,1.)
              call to_history("From Data: d5",data_par%d_hy)
              call from_aux(trim(data_par%tag),"o4",data_par%t_0,0.)
              call to_history("From Data: o4",data_par%t_0)
              call from_aux(trim(data_par%tag),"o5",data_par%hy_0,0.)
              call to_history("From Data: o5",data_par%hy_0)
           end if
  
         else if_comp_domain_data_2

           call from_aux(trim(data_par%tag),"n1",data_par%n_off_x)
           call to_history("From Data: n1",data_par%n_off_x)
           call from_aux(trim(data_par%tag),"o1",data_par%off_x_0,0.)
           call to_history("From Data: o1",data_par%off_x_0)
           call from_aux(trim(data_par%tag),"d1",data_par%d_off_x)
           call to_history("From Data: d1",data_par%d_off_x)
  
           if(gen_par%n_data_dim >4) then 
             call from_aux(trim(data_par%tag),"n2",data_par%n_off_y)
             call to_history("From Data: n2",data_par%n_off_y)
             call from_aux(trim(data_par%tag),"n3",data_par%n_t)
             call to_history("From Data: n3",data_par%n_t)
             call from_aux(trim(data_par%tag),"n4",data_par%n_sx)
             call to_history("From Data: n4",data_par%n_sy)
             call from_aux(trim(data_par%tag),"n5",data_par%n_sy)
             call to_history("From Data: n5",data_par%n_sy)

             call from_aux(trim(data_par%tag),"d2",data_par%d_off_y)
             call to_history("From Data: d2",data_par%d_off_y)
             call from_aux(trim(data_par%tag),"d3",data_par%d_t)
             call to_history("From Data: d3",data_par%d_t)
             call from_aux(trim(data_par%tag),"d4",data_par%d_sx)
             call to_history("From Data: d4",data_par%d_sy)
             call from_aux(trim(data_par%tag),"d5",data_par%d_sy)
             call to_history("From Data: d5",data_par%d_sy)

             call from_aux(trim(data_par%tag),"o2",data_par%off_y_0)
             call to_history("From Data: o2",data_par%off_y_0)
             call from_aux(trim(data_par%tag),"o3",data_par%t_0)
             call to_history("From Data: o3",data_par%t_0)
             call from_aux(trim(data_par%tag),"o4",data_par%sx_0)
             call to_history("From Data: o4",data_par%sy_0)
             call from_aux(trim(data_par%tag),"o5",data_par%sy_0)
             call to_history("From Data: o5",data_par%sy_0)
           else
             call from_aux(trim(data_par%tag),"n2",data_par%n_t)
             call to_history("From Data: n2",data_par%n_t)
             call from_aux(trim(data_par%tag),"n3",data_par%n_sx)
             call to_history("From Data: n3",data_par%n_sx)
             call from_aux(trim(data_par%tag),"n4",data_par%n_sy)
             call to_history("From Data: n4",data_par%n_sy)

             call from_aux(trim(data_par%tag),"d2",data_par%d_t)
             call to_history("From Data: d2",data_par%d_t)
             call from_aux(trim(data_par%tag),"d3",data_par%d_sx)
             call to_history("From Data: d3",data_par%d_sx)
             call from_aux(trim(data_par%tag),"d4",data_par%d_sy)
             call to_history("From Data: d4",data_par%d_sy)

             call from_aux(trim(data_par%tag),"o2",data_par%t_0)
             call to_history("From Data: o2",data_par%t_0)
             call from_aux(trim(data_par%tag),"o3",data_par%sx_0)
             call to_history("From Data: o3",data_par%sx_0)
             call from_aux(trim(data_par%tag),"o4",data_par%sy_0)
             call to_history("From Data: o4",data_par%sy_0)

	     data_par%n_off_y=1
	     data_par%d_off_y=1.
	     data_par%off_y_0=0.
           end if
  
         end if if_comp_domain_data_2

         if(gen_par%tau_domain) then
           call from_aux(trim(data_par%tag),"tau_data_0",data_par%tau_0)
         else
           call from_aux(trim(data_par%tag),"z_data_0",data_par%z_0)
         end if
         if(esize /= data_par%esize) call seperr('Data must be real')
!         if(image_par%z_image_0 < data_par%z_0 ) then
!            write(0,*)'gen_par%z_image_0=',gen_par%z_image_0
!            write(0,*)'data_par%z_0=',data_par%z_0
!            call seperr('z_image_0 < data_par-z_0')
!         end if
         if(gen_par%debug1) write(0,*)'data_file=',data_par%file

         !}
       end if
       !}
    else
     !{
     !}
  end if

   return
end subroutine param_data


subroutine param_image(gen_par,data_par,image_par,wavelet_par)
  use sep
  use genrev3d_types
  use data_types
  use image_types
  use wavelet_types

  implicit none

  character(len=128) :: tag_name,tag_hz_name
  type (genrev3d_param_type) gen_par
  type (data_param_type) data_par
  type (image_param_type) image_par
  type (wavelet_param_type) wavelet_par
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout,auxinout


  logical write_image
  integer esize,ierr
  integer n1_image,n2_image,n3_image,n4_image,n5_image,n6_image,n7_image
  real o1_image,o2_image,o3_image,o4_image,o5_image,o6_image,o7_image
  real d1_image,d2_image,d3_image,d4_image,d5_image,d6_image,d7_image
  real t_0_lag_image

  call from_param('write_image_progress',image_par%write_image_progress,.false.)
  call from_param('write_image_hz',image_par%write_image_hz,.false.)
  call from_param('image_memory',image_par%image_memory,.true.)

  image_par%esize=4

  ! image parameters
  call from_param('tag_image',image_par%tag,'Image')
  call from_param(trim(image_par%tag),tag_name,'Image not found')

  if(image_par%write_image_hz) then
    call from_param('tag_image_hz',image_par%tag_hz,'Image_hz')
    call from_param(trim(image_par%tag_hz),tag_hz_name,'Image_hz not found')
  end if

  ! find out what to do with image file
  if_comp_domain_image_1 : if (gen_par%comp_domain(1:4) == 'midp') then

    if ((.not. gen_par%first_adj) .and. (gen_par%domain_range(6:9) == 'imag')) then
       image_par%file=IMAGE_INPUT
       if (auxinout(trim(image_par%tag)) <= 0) call seperr('Could not find file Image')
    else
       call from_param('write_image',write_image,.true.)
       if(write_image) then
          image_par%file=IMAGE_OUTPUT
       else
          image_par%file=IMAGE_NO_FILE
       end if
    end if
  else if_comp_domain_image_1
    if ((gen_par%first_adj) .and. (gen_par%domain_range(6:9) == 'imag')) then
      call from_param('write_image',write_image,.true.)
      if(write_image) then
         image_par%file=IMAGE_OUTPUT
      else
         image_par%file=IMAGE_NO_FILE
      end if
    end if
  end if if_comp_domain_image_1

  if(gen_par%debug1) write(0,*)'image_file=',image_par%file

  if (image_par%file == IMAGE_INPUT) then
     !{
     call from_aux(trim(image_par%tag),"esize",esize)
     if(gen_par%tau_domain) then
       call from_aux(trim(image_par%tag),"n1",image_par%n_tau)
       call from_aux(trim(image_par%tag),"d1",image_par%d_tau)
       call from_aux(trim(image_par%tag),"o1",image_par%tau_0)
     else
       call from_aux(trim(image_par%tag),"n1",image_par%n_z)
       call from_aux(trim(image_par%tag),"d1",image_par%d_z)
       call from_aux(trim(image_par%tag),"o1",image_par%z_0)
     end if

     call from_aux(trim(image_par%tag),"n2",image_par%n_mx)
     call from_aux(trim(image_par%tag),"n3",image_par%n_my)

     call from_aux(trim(image_par%tag),"d2",image_par%d_mx)
     call from_aux(trim(image_par%tag),"d3",image_par%d_my)

     call from_aux(trim(image_par%tag),"o2",image_par%mx_0)
     call from_aux(trim(image_par%tag),"o3",image_par%my_0)

     if(.not.gen_par%image_zero_offset) then
       if(gen_par%surf_offset_cig) then
         call from_aux(trim(image_par%tag),"n4",image_par%n_sx)
         call from_aux(trim(image_par%tag),"n5",image_par%n_sy)
         call from_aux(trim(image_par%tag),"d4",image_par%d_sx)
         call from_aux(trim(image_par%tag),"d5",image_par%d_sy)
         call from_aux(trim(image_par%tag),"o4",image_par%sx_0)
         call from_aux(trim(image_par%tag),"o5",image_par%sy_0)
         image_par%n_hx=1
         image_par%hx_0=0.
         image_par%n_hy=1
         image_par%hy_0=0.
       else
         call from_aux(trim(image_par%tag),"n4",image_par%n_hx)
         call from_aux(trim(image_par%tag),"n5",image_par%n_hy)
         call from_aux(trim(image_par%tag),"d4",image_par%d_hx)
         call from_aux(trim(image_par%tag),"d5",image_par%d_hy)
         call from_aux(trim(image_par%tag),"o4",image_par%hx_0)
         call from_aux(trim(image_par%tag),"o5",image_par%hy_0)
       end if
     end if

     if(esize /= image_par%esize) call seperr('Image of wrong type')

!     if(n1  n1_image ) call seperr('Image n1 is uncons. with Data')
!     if(n2 /= n2_image ) call seperr('Image n2 is uncons. with Data')
!
!     if(d1 /= d1_image ) call seperr('Image d1 is unconsis. with Data')
!     if(d2 /= d2_image ) call seperr('Image d2 is unconsis. with Data')
!
!     if(o1 /= o1_image ) call seperr('Image o1 is unconsis. with Data')
!     if(o2 /= o2_image ) call seperr('Image o2 is unconsis. with Data')
!
!     if(n3 /= n3_image ) call seperr('Image n3 is uncons. with Data')
!     if(d3 /= d3_image ) call seperr('Image d3 is uncons. with Data')
!     if(o3 /= o3_image ) call seperr('Image o3 is uncons. with Data')
!
!     if(.not.gen_par%image_zero_offset) then
!        if(n4 /= n4_image ) call seperr('Image n4 is uncons. with Data')
!        if(d4 /= d4_image ) call seperr('Image d4 is unconsis. with Data')
!        if(o4 /= o4_image ) call seperr('Image o4 is unconsis. with Data')
!        if(n5 /= n5_image ) call seperr('Image n5 is unconsis. with Data')
!        if(d5 /= d5_image ) call seperr('Image d5 is unconsis. with Data')
!        if(o5 /= o5_image ) call seperr('Image o5 is unconsis. with Data')
!     end if

     !}
  else
     !{
     if(image_par%file == IMAGE_OUTPUT) then
        !{

       if(gen_par%tau_domain) then
         call from_param('n_tau_image',image_par%n_tau)
         call from_param('tau_image_0',image_par%tau_0,0.)
         call from_param('d_tau_image',image_par%d_tau)
       else
         call from_param('n_z_image',image_par%n_z)
         call from_param('z_image_0',image_par%z_0,0.)
         call from_param('d_z_image',image_par%d_z)
       end if

       if_comp_domain_image_2 : if (gen_par%comp_domain(1:4) == 'midp') then

        call from_param('n_mx_image',image_par%n_mx,integer_init)
        if(image_par%n_mx == integer_init) image_par%n_mx=data_par%n_mx
        call from_param('mx_image_0',image_par%mx_0,real_init)
        if(image_par%mx_0 == real_init) image_par%mx_0=data_par%mx_0
        call from_param('d_mx_image',image_par%d_mx,real_init)
        if(image_par%d_mx == real_init) image_par%d_mx=data_par%d_mx

        call from_param('n_my_image',image_par%n_my,integer_init)
        if(image_par%n_my == integer_init) image_par%n_my=data_par%n_my
        call from_param('my_image_0',image_par%my_0,real_init)
        if(image_par%my_0 == real_init) image_par%my_0=data_par%my_0
        call from_param('d_my_image',image_par%d_my,real_init)
        if(image_par%d_my == real_init) image_par%d_my=data_par%d_my

        call from_param('n_t_lag_image',image_par%n_t_lag,1)
        call from_param('d_t_lag_image',image_par%d_t_lag,-data_par%d_t)

        t_0_lag_image=-image_par%d_t_lag*(image_par%n_t_lag-1)/2
        call from_param('t_0_lag_image',image_par%t_0_lag,t_0_lag_image)

        if(gen_par%image_zero_offset) then
          image_par%n_hx=1
          image_par%n_hy=1
          image_par%hx_0=0.
          image_par%hy_0=0.
          image_par%d_hx=1.
          image_par%d_hy=1.
        else
          call from_param('n_hx_image',image_par%n_hx,integer_init)
          if(image_par%n_hx == integer_init) image_par%n_hx=data_par%n_hx
          call from_param('hx_image_0',image_par%hx_0,real_init)
          if(image_par%hx_0 == real_init) image_par%hx_0=data_par%hx_0
          call from_param('d_hx_image',image_par%d_hx,real_init)
          if(image_par%d_hx == real_init) image_par%d_hx=data_par%d_hx

          call from_param('n_hy_image',image_par%n_hy,integer_init)
          if(image_par%n_hy == integer_init) image_par%n_hy=data_par%n_hy
          call from_param('hy_image_0',image_par%hy_0,real_init)
          if(image_par%hy_0 == real_init) image_par%hy_0=data_par%hy_0
          call from_param('d_hy_image',image_par%d_hy,real_init)
          if(image_par%d_hy == real_init) image_par%d_hy=data_par%d_hy
        end if

        n3_image=image_par%n_my
        o3_image=image_par%my_0
        d3_image=image_par%d_my

        n4_image=image_par%n_hx
        o4_image=image_par%hx_0
        d4_image=image_par%d_hx

      else if_comp_domain_image_2

        call from_param('d_t_image',image_par%d_t,data_par%d_t)
        call from_param('t_0_image',image_par%t_0,data_par%t_0)
        image_par%n_t=(data_par%t_0+(data_par%n_t-1)*data_par%d_t-image_par%t_0)/&
                      image_par%d_t + 1
!                      image_par%d_t + 2
        call from_param('n_t_image',image_par%n_t,image_par%n_t)

        call from_param('n_mx_image',image_par%n_mx)
        call from_param('mx_image_0',image_par%mx_0)
        call from_param('d_mx_image',image_par%d_mx)

        call from_param('n_my_image',image_par%n_my)
        call from_param('my_image_0',image_par%my_0)
        call from_param('d_my_image',image_par%d_my)

        call from_param('n_t_lag_image',image_par%n_t_lag,1)
        call from_param('d_t_lag_image',image_par%d_t_lag,image_par%d_t)

        t_0_lag_image=-image_par%d_t_lag*(image_par%n_t_lag-1)/2
        call from_param('t_0_lag_image',image_par%t_0_lag,t_0_lag_image)

        if(gen_par%image_zero_offset) then
        !{
          if(gen_par%surf_offset_cig) then

            image_par%n_sx=data_par%n_sx
            image_par%n_sy=data_par%n_sy
            image_par%sx_0=data_par%sx_0
            image_par%sy_0=data_par%sy_0
            image_par%d_sx=data_par%d_sx
            image_par%d_sy=data_par%d_sy

            n2_image=image_par%n_mx
            o2_image=image_par%mx_0
            d2_image=image_par%d_mx

            n3_image=image_par%n_my
            o3_image=image_par%my_0
            d3_image=image_par%d_my

            n4_image=image_par%n_sx
            o4_image=image_par%sx_0
            d4_image=image_par%d_sx
    
            n5_image=image_par%n_sy
            o5_image=image_par%sy_0
            d5_image=image_par%d_sy

            image_par%n_hx=1
            image_par%hx_0=0.
            image_par%n_hy=1
            image_par%hy_0=0.

          else
            image_par%n_hx=1
            image_par%n_hy=1
            image_par%hx_0=0.
            image_par%hy_0=0.
            image_par%d_hx=1.
            image_par%d_hy=1.

            n2_image=image_par%n_mx
            o2_image=image_par%mx_0
            d2_image=image_par%d_mx

            n3_image=image_par%n_my
            o3_image=image_par%my_0
            d3_image=image_par%d_my

            n4_image=image_par%n_hx
            o4_image=image_par%hx_0
            d4_image=image_par%d_hx

            n5_image=image_par%n_hy
            o5_image=image_par%hy_0
            d5_image=image_par%d_hy

          end if
        !}
        else
        !{
          call from_param('n_hx_image',image_par%n_hx)
          call from_param('d_hx_image',image_par%d_hx)
          image_par%hx_0=-int((image_par%n_hx-1)/2)*image_par%d_hx
          call from_param('hx_image_0',image_par%hx_0,image_par%hx_0)
  
          call from_param('n_hy_image',image_par%n_hy)
          call from_param('d_hy_image',image_par%d_hy)
          image_par%hy_0=-int((image_par%n_hy-1)/2)*image_par%d_hy
          call from_param('hy_image_0',image_par%hy_0,image_par%hy_0)

          n2_image=image_par%n_mx
          o2_image=image_par%mx_0
          d2_image=image_par%d_mx

          n3_image=image_par%n_hx
          o3_image=image_par%hx_0
          d3_image=image_par%d_hx
  
          n4_image=image_par%n_my
          o4_image=image_par%my_0
          d4_image=image_par%d_my
  
          n5_image=image_par%n_hy
          o5_image=image_par%hy_0
          d5_image=image_par%d_hy

        !}
        end if

      end if if_comp_domain_image_2

        if(gen_par%tau_domain) then
          n1_image=image_par%n_tau
          o1_image=image_par%tau_0
          d1_image=image_par%d_tau
        else
          n1_image=image_par%n_z
          o1_image=image_par%z_0
          d1_image=image_par%d_z
        end if

        if(image_par%write_image_progress) then

          n6_image=image_par%n_t_lag
          o6_image=image_par%t_0_lag
          d6_image=image_par%d_t_lag

          n7_image=image_par%n_t
!          o7_image=(rev_extrap_par%t_0_second+wavelet_par%t_delay)
          o7_image=image_par%t_0+(image_par%n_t-1)*image_par%d_t
          d7_image=-image_par%d_t

        else
          n6_image=image_par%n_t_lag
          o6_image=image_par%t_0_lag
          d6_image=image_par%d_t_lag

          n7_image=1
          o7_image=0.
          d7_image=1.
        end if

        ierr=auxinout(trim(image_par%tag))

        call to_history("esize",image_par%esize,trim(image_par%tag))
        call to_history("n1",n1_image,trim(image_par%tag))
        call to_history("n2",n2_image,trim(image_par%tag))
        call to_history("n3",n3_image,trim(image_par%tag))
        call to_history("n4",n4_image,trim(image_par%tag))
        call to_history("n5",n5_image,trim(image_par%tag))
        call to_history("n6",n6_image,trim(image_par%tag))
        call to_history("n7",n7_image,trim(image_par%tag))

        call to_history("d1",d1_image,trim(image_par%tag))
        call to_history("d2",d2_image,trim(image_par%tag))
        call to_history("d3",d3_image,trim(image_par%tag))
        call to_history("d4",d4_image,trim(image_par%tag))
        call to_history("d5",d5_image,trim(image_par%tag))
        call to_history("d6",d6_image,trim(image_par%tag))
        call to_history("d7",d7_image,trim(image_par%tag))

        call to_history("o1",o1_image,trim(image_par%tag))
        call to_history("o2",o2_image,trim(image_par%tag))
        call to_history("o3",o3_image,trim(image_par%tag))
        call to_history("o4",o4_image,trim(image_par%tag))
        call to_history("o5",o5_image,trim(image_par%tag))
        call to_history("o6",o6_image,trim(image_par%tag))
        call to_history("o7",o7_image,trim(image_par%tag))

!       Guojian
        if(image_par%write_image_hz) then
          ierr=auxinout(trim(image_par%tag_hz))
  
          call to_history("esize",image_par%esize,trim(image_par%tag_hz))
          call to_history("n1",n1_image,trim(image_par%tag_hz))
          call to_history("n2",n2_image,trim(image_par%tag_hz))
          call to_history("n3",n3_image,trim(image_par%tag_hz))
          call to_history("n4",n4_image,trim(image_par%tag_hz))
          call to_history("n5",n5_image,trim(image_par%tag_hz))
          call to_history("n6",n6_image,trim(image_par%tag_hz))
          call to_history("n7",n7_image,trim(image_par%tag_hz))
  
          call to_history("d1",d1_image,trim(image_par%tag_hz))
          call to_history("d2",d2_image,trim(image_par%tag_hz))
          call to_history("d3",d3_image,trim(image_par%tag_hz))
          call to_history("d4",d4_image,trim(image_par%tag_hz))
          call to_history("d5",d5_image,trim(image_par%tag_hz))
          call to_history("d6",d6_image,trim(image_par%tag_hz))
          call to_history("d7",d7_image,trim(image_par%tag_hz))
  
          call to_history("o1",o1_image,trim(image_par%tag_hz))
          call to_history("o2",o2_image,trim(image_par%tag_hz))
          call to_history("o3",o3_image,trim(image_par%tag_hz))
          call to_history("o4",o4_image,trim(image_par%tag_hz))
          call to_history("o5",o5_image,trim(image_par%tag_hz))
          call to_history("o6",o6_image,trim(image_par%tag_hz))
          call to_history("o7",o7_image,trim(image_par%tag_hz))
        end if

!       end Guojian

        !}
     end if
     !}
  end if

   return
end subroutine param_image

subroutine param_extrap(gen_par,data_par,image_par,wavelet_par,rev_extrap_par)

  use sep
  use genrev3d_types
  use data_types
  use image_types
  use wavelet_types
  use rev_extrap_types

  implicit none

  type (genrev3d_param_type) gen_par
  type (data_param_type) data_par
  type (image_param_type) image_par
  type (wavelet_param_type) wavelet_par
  type (rev_extrap_param_type) rev_extrap_par

  integer n_t_delay,n_t,n_t_extrap
  real t_extrap_0,d_t,t_0

  ! rev_extrap parameters

  if_comp_domain_extrap_1 : if (gen_par%comp_domain(1:4) == 'midp') then

    if (gen_par%first_adj) then
      n_t_extrap=data_par%n_t + &
        nint((image_par%t_0_lag + image_par%d_t_lag*(image_par%n_t_lag-1))/ &
              image_par%d_t_lag) -1
      call from_param('n_t_extrap',n_t,n_t_extrap)
      rev_extrap_par%n_t_second=n_t
  
      call from_param('d_t_extrap',d_t,-data_par%d_t)
      rev_extrap_par%d_t_second=d_t
      rev_extrap_par%d_t=abs(d_t)
  
      t_extrap_0=min((rev_extrap_par%n_t_second-1)*(-rev_extrap_par%d_t_second),&
                     (data_par%n_t-1)*data_par%d_t &
                    )
      call from_param('t_extrap_0',t_0,t_extrap_0)
      rev_extrap_par%t_0_second=t_0
    else
  !    rev_extrap_par%adj=.false.
      call from_param('n_t_extrap',n_t,data_par%n_t+n_t_delay)
      rev_extrap_par%n_t_first=0
      rev_extrap_par%n_t_second=n_t
  
      call from_param('d_t_extrap',d_t,data_par%d_t)
      rev_extrap_par%d_t_first=0.
      rev_extrap_par%d_t_second=d_t
      rev_extrap_par%d_t=abs(d_t)
  
      call from_param('t_extrap_0',t_0,data_par%t_0-wavelet_par%t_delay)
      rev_extrap_par%t_0_first=0.
      rev_extrap_par%t_0_second=t_0
    end if


  else if_comp_domain_extrap_1

  n_t_delay=wavelet_par%t_delay/wavelet_par%d_t
  write(0,*)'n_t_delay=',n_t_delay

    if (gen_par%first_adj) then
  !    rev_extrap_par%adj=.true.
      call from_param('n_t_extrap',n_t,data_par%n_t)
  !    rev_extrap_par%n_t_first=n_t-1+n_t_delay
      rev_extrap_par%n_t_first=n_t+n_t_delay
  !    rev_extrap_par%n_t_second=n_t
      rev_extrap_par%n_t_second=image_par%n_t
  
      call from_param('d_t_extrap',d_t,-data_par%d_t)
      rev_extrap_par%d_t_first=-d_t
      rev_extrap_par%d_t_second=d_t
      rev_extrap_par%d_t=abs(d_t)
  
  !    t_extrap_0=(rev_extrap_par%n_t_second-1)*(-rev_extrap_par%d_t_second)
      t_extrap_0=(rev_extrap_par%n_t_second-1)*(-rev_extrap_par%d_t_second) + &
                  image_par%t_0
      call from_param('t_extrap_0',t_0,t_extrap_0)
      rev_extrap_par%t_0_first=-wavelet_par%t_delay
      rev_extrap_par%t_0_second=t_0
    else
  !    rev_extrap_par%adj=.false.
      call from_param('n_t_extrap',n_t,data_par%n_t+n_t_delay)
      rev_extrap_par%n_t_first=0
      rev_extrap_par%n_t_second=n_t
  
      call from_param('d_t_extrap',d_t,data_par%d_t)
      rev_extrap_par%d_t_first=0.
      rev_extrap_par%d_t_second=d_t
      rev_extrap_par%d_t=abs(d_t)
  
      call from_param('t_extrap_0',t_0,data_par%t_0-wavelet_par%t_delay)
      rev_extrap_par%t_0_first=0.
      rev_extrap_par%t_0_second=t_0
    end if

  end if if_comp_domain_extrap_1

  rev_extrap_par%n_threads=gen_par%n_threads

  return
end subroutine param_extrap

subroutine param_wave(gen_par,data_par,rev_extrap_par,image_par,wavelet_par, &
                      wave_par)
  use sep
  use genrev3d_types
  use data_types
  use rev_extrap_types
  use image_types
  use wavelet_types
  use wave_types

  implicit none

  type (genrev3d_param_type) gen_par
  type (data_param_type) data_par
  type (rev_extrap_param_type) rev_extrap_par
  type (image_param_type) image_par
  type (wavelet_param_type) wavelet_par
  type (wave_param_type) wave_par

  logical write_wavefield,read_wavefield
  character(len=128) :: tag_name
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout,auxinout
  integer esize, ierr
  integer n1,n2,n3,n4,n5,n6,n_t_snap
  integer source_n_t
  real t_extrap,source_d_t,source_t_0
  real o1,o2,o3,o4,o5,o6
  real d1,d2,d3,d4,d5,d6
  real pi


  wave_par%esize=4


  call from_param('read_wavefield',read_wavefield,.false.)
  call from_param('write_wavefield', write_wavefield,.false.)


  if_comp_domain_wave_1 : if (gen_par%comp_domain(1:4) == 'midp') then

    if(gen_par%tau_domain) then
      call from_param('n_tau_pad',wave_par%n_tau,-integer_init)
      if((wave_par%n_tau > 0).and. (wave_par%n_tau > image_par%n_tau)) then
         wave_par%n_tau=wave_par%n_tau
      else
         wave_par%n_tau=image_par%n_tau
      end if
      wave_par%tau_0=image_par%tau_0
      wave_par%d_tau=image_par%d_tau
    else
      call from_param('n_z_pad',wave_par%n_z,-integer_init)
      if((wave_par%n_z > 0).and. (wave_par%n_z > image_par%n_z)) then
         wave_par%n_z=wave_par%n_z
      else
         wave_par%n_z=image_par%n_z
      end if
      wave_par%z_0=image_par%z_0
      wave_par%d_z=image_par%d_z
    end if

    call from_param('n_mx_pad',wave_par%n_mx,-integer_init)

    if((wave_par%n_mx > 0).and. (wave_par%n_mx > data_par%n_mx)) then
       wave_par%n_mx=wave_par%n_mx
       call from_param('mx_0_pad',wave_par%mx_0,-real_init)
       if(wave_par%mx_0 == -real_init) wave_par%mx_0=data_par%mx_0
    else
       wave_par%n_mx=data_par%n_mx
       wave_par%mx_0=data_par%mx_0
    end if
    wave_par%d_mx=data_par%d_mx
  
    call from_param('n_my',wave_par%n_my,-integer_init)
    if((wave_par%n_my > 0).and. (wave_par%n_my > data_par%n_my)) then
       wave_par%n_my=wave_par%n_my
       call from_param('my_0_pad',wave_par%my_0,-real_init)
       if(wave_par%my_0 == -real_init) wave_par%my_0=data_par%my_0
    else
       wave_par%n_my=data_par%n_my
       wave_par%my_0=data_par%my_0
    end if
    wave_par%d_my=data_par%d_my
  
    call from_param('n_hx',wave_par%n_hx,-integer_init)
    if((wave_par%n_hx > 0).and. (wave_par%n_hx > data_par%n_hx)) then
       wave_par%n_hx=wave_par%n_hx
       call from_param('hx_0_pad',wave_par%hx_0,-real_init)
       if(wave_par%hx_0 == -real_init) wave_par%hx_0=data_par%hx_0
    else
       wave_par%n_hx=data_par%n_hx
       wave_par%hx_0=data_par%hx_0
    end if
    wave_par%d_hx=data_par%d_hx
  
    call from_param('n_hy_pad',wave_par%n_hy,-integer_init)
    if((wave_par%n_hy > 0).and. (wave_par%n_hy > data_par%n_hy)) then
       wave_par%n_hy=wave_par%n_hy
       call from_param('hy_0_pad',wave_par%hy_0,-real_init)
       if(wave_par%hy_0 == -real_init) wave_par%hy_0=data_par%hy_0
    else
       wave_par%n_hy=data_par%n_hy
       wave_par%hy_0=data_par%hy_0
    end if
    wave_par%d_hy=data_par%d_hy

    wave_par%n_sx=1
    wave_par%n_sy=1

  else if_comp_domain_wave_1

    if(gen_par%tau_domain) then
      call from_param('n_tau',wave_par%n_tau,image_par%n_tau)
      call from_param('tau_0',wave_par%tau_0,image_par%tau_0)
      call from_param('d_tau',wave_par%d_tau,image_par%d_tau)

    else
      call from_param('n_z',wave_par%n_z,image_par%n_z)
      call from_param('z_0',wave_par%z_0,image_par%z_0)
      call from_param('d_z',wave_par%d_z,image_par%d_z)
    end if

    call from_param('n_off_x_pad',wave_par%n_off_x,-integer_init)
    if((wave_par%n_off_x > 0).and. (wave_par%n_off_x > data_par%n_off_x)) then
       wave_par%n_off_x=wave_par%n_off_x
       wave_par%n_mx=wave_par%n_off_x
       call from_param('off_x_0_pad',wave_par%off_x_0,-real_init)
       if(wave_par%off_x_0 == -real_init) wave_par%off_x_0=data_par%off_x_0
    else
       wave_par%n_off_x=data_par%n_off_x
       wave_par%n_mx=data_par%n_off_x
       wave_par%off_x_0=data_par%off_x_0
       call to_history("n_off_x_pad",wave_par%n_off_x)
       call to_history("off_x_0_pad",wave_par%off_x_0)
    end if
    wave_par%d_off_x=data_par%d_off_x
    wave_par%d_mx=data_par%d_off_x
  
    call from_param('n_off_y_pad',wave_par%n_off_y,-integer_init)
    if((wave_par%n_off_y > 0).and. (wave_par%n_off_y > data_par%n_off_y)) then
       wave_par%n_off_y=wave_par%n_off_y
       wave_par%n_my=wave_par%n_off_y
       call from_param('off_y_0_pad',wave_par%off_y_0,-real_init)
       if(wave_par%off_y_0 == -real_init) wave_par%off_y_0=data_par%off_y_0
    else
       wave_par%n_off_y=data_par%n_off_y
       wave_par%n_my=data_par%n_off_y
       wave_par%off_y_0=data_par%off_y_0
       call to_history("n_off_y_pad",wave_par%n_off_y)
       call to_history("off_y_0_pad",wave_par%off_y_0)
    end if
    wave_par%d_off_y=data_par%d_off_y
    wave_par%d_my=data_par%d_off_y

    wave_par%n_hx=1
    wave_par%d_hx=data_par%d_off_x
    wave_par%n_hy=1
    wave_par%d_hy=data_par%d_off_y

    wave_par%n_sx=data_par%n_sx
    wave_par%d_sx=data_par%d_sx
    wave_par%sx_0=data_par%sx_0
    wave_par%n_sy=data_par%n_sy
    wave_par%d_sy=data_par%d_sy
    wave_par%sy_0=data_par%sy_0

    if(gen_par%first_adj .and. (image_par%file == IMAGE_OUTPUT)) then
      call from_param('tag_wavefield_tmp',wave_par%tag_2,'Wavefield_tmp')
      call from_param(trim(wave_par%tag_2),tag_name,'Wavefield_tmp not found')
      ierr=auxinout(trim(wave_par%tag_2))
  
      call to_history("esize",data_par%esize,trim(wave_par%tag_2))
      if(gen_par%tau_domain) then
        call to_history("n1",wave_par%n_tau,trim(wave_par%tag_2))
        call to_history("d1",wave_par%d_tau,trim(wave_par%tag_2))
        call to_history("o1",wave_par%tau_0,trim(wave_par%tag_2))
      else
        call to_history("n1",wave_par%n_z,trim(wave_par%tag_2))
        call to_history("d1",wave_par%d_z,trim(wave_par%tag_2))
        call to_history("o1",wave_par%z_0,trim(wave_par%tag_2))
      end if
      call to_history("n2",wave_par%n_off_x,trim(wave_par%tag_2))
      call to_history("d2",wave_par%d_off_x,trim(wave_par%tag_2))
      call to_history("o2",wave_par%off_x_0,trim(wave_par%tag_2))
  
      if(gen_par%n_data_dim >4) then 
        call to_history("n3",wave_par%n_off_y,trim(wave_par%tag_2))
        call to_history("d3",wave_par%d_off_y,trim(wave_par%tag_2))
        call to_history("o3",wave_par%off_y_0,trim(wave_par%tag_2))
  
        call to_history("n4",image_par%n_t,trim(wave_par%tag_2))
        call to_history("d4",image_par%d_t,trim(wave_par%tag_2))
        call to_history("o4",image_par%t_0,trim(wave_par%tag_2))
      else
        call to_history("n3",image_par%n_t,trim(wave_par%tag_2))
        call to_history("d3",image_par%d_t,trim(wave_par%tag_2))
        call to_history("o3",image_par%t_0,trim(wave_par%tag_2))
      end if
    end if

  end if if_comp_domain_wave_1

  ! wavefield parameters
  wave_par%file=WAVE_NO_FILE
  if(write_wavefield) then
    !{
    wave_par%file=WAVE_OUTPUT

    call from_param('d_t_snap',wave_par%d_t,rev_extrap_par%d_t_second)
    if (gen_par%first_adj) then
      call from_param('t_0_snap',wave_par%t_0,rev_extrap_par%t_0_second)
      n_t_snap=-(wave_par%t_0)/wave_par%d_t+1
      call from_param('n_t_snap',wave_par%n_t,n_t_snap)
    else
      call from_param('t_0_snap',wave_par%t_0,rev_extrap_par%t_0_second+wavelet_par%t_delay)
      n_t_snap=int(( &
        rev_extrap_par%n_t_second*rev_extrap_par%d_t_second+rev_extrap_par%t_0_second)/ &
                         wave_par%d_t)+1
      call from_param('n_t_snap',wave_par%n_t,n_t_snap)
    end if

    if_comp_domain_wave_2 : if (gen_par%comp_domain(1:4) == 'midp') then

      call from_param('tag_wavefield',wave_par%tag,'Wavefield')
      call from_param(trim(wave_par%tag),tag_name,'Wavefield not found')
      ierr=auxinout(trim(wave_par%tag))

      call to_history("esize",data_par%esize,trim(wave_par%tag))
      if(gen_par%tau_domain) then
        call to_history("n1",wave_par%n_tau,trim(wave_par%tag))
        call to_history("d1",wave_par%d_tau,trim(wave_par%tag))
        call to_history("o1",wave_par%tau_0,trim(wave_par%tag))
      else
        call to_history("n1",wave_par%n_z,trim(wave_par%tag))
        call to_history("d1",wave_par%d_z,trim(wave_par%tag))
        call to_history("o1",wave_par%z_0,trim(wave_par%tag))
      end if
      call to_history("n2",wave_par%n_mx,trim(wave_par%tag))
      call to_history("n3",wave_par%n_my,trim(wave_par%tag))
      call to_history("n4",wave_par%n_hx,trim(wave_par%tag))
      call to_history("n5",wave_par%n_hy,trim(wave_par%tag))
      call to_history("n6",wave_par%n_t,trim(wave_par%tag))
 
      call to_history("d2",wave_par%d_mx,trim(wave_par%tag))
      call to_history("d3",wave_par%d_my,trim(wave_par%tag))
      call to_history("d4",wave_par%d_hx,trim(wave_par%tag))
      call to_history("d5",wave_par%d_hy,trim(wave_par%tag))
      call to_history("d6",wave_par%d_t,trim(wave_par%tag))
 
      call to_history("o2",wave_par%mx_0,trim(wave_par%tag))
      call to_history("o3",wave_par%my_0,trim(wave_par%tag))
      call to_history("o4",wave_par%hx_0,trim(wave_par%tag))
      call to_history("o5",wave_par%hy_0,trim(wave_par%tag))
      call to_history("o6",wave_par%t_0,trim(wave_par%tag))

    else if_comp_domain_wave_2

      if (gen_par%first_adj) then
      !{
        call from_param('tag_wavefield_sou',wave_par%tag_1,'Wavefield_sou')
        call from_param(trim(wave_par%tag_1),tag_name,'Wavefield_sou not found')
        ierr=auxinout(trim(wave_par%tag_1))

        call from_param('tag_wavefield_rec',wave_par%tag,'Wavefield_rec')
        call from_param(trim(wave_par%tag),tag_name,'Wavefield_rec not found')
        ierr=auxinout(trim(wave_par%tag))
      !}
      else
      !{
        call from_param('tag_wavefield_sou',wave_par%tag,'Wavefield_sou')
        call from_param(trim(wave_par%tag),tag_name,'Wavefield_sou not found')
        ierr=auxinout(trim(wave_par%tag))
      !}
      end if

      call to_history("esize",data_par%esize,trim(wave_par%tag))
      if(gen_par%tau_domain) then
        call to_history("n1",wave_par%n_tau,trim(wave_par%tag))
        call to_history("d1",wave_par%d_tau,trim(wave_par%tag))
        call to_history("o1",wave_par%tau_0,trim(wave_par%tag))
      else
        call to_history("n1",wave_par%n_z,trim(wave_par%tag))
        call to_history("d1",wave_par%d_z,trim(wave_par%tag))
        call to_history("o1",wave_par%z_0,trim(wave_par%tag))
      end if
      call to_history("n2",wave_par%n_off_x,trim(wave_par%tag))
      call to_history("d2",wave_par%d_off_x,trim(wave_par%tag))
      call to_history("o2",wave_par%off_x_0,trim(wave_par%tag))

      if(gen_par%n_data_dim >4) then 
      !{
        call to_history("n3",wave_par%n_off_y,trim(wave_par%tag))
        call to_history("d3",wave_par%d_off_y,trim(wave_par%tag))
        call to_history("o3",wave_par%off_y_0,trim(wave_par%tag))
  
        call to_history("n4",wave_par%n_t,trim(wave_par%tag))
        call to_history("d4",wave_par%d_t,trim(wave_par%tag))
        call to_history("o4",wave_par%t_0,trim(wave_par%tag))
  
        call to_history("n5",wave_par%n_sx,trim(wave_par%tag))
        call to_history("d5",wave_par%d_sx,trim(wave_par%tag))
        call to_history("o5",wave_par%sx_0,trim(wave_par%tag))
  
        call to_history("n6",wave_par%n_sy,trim(wave_par%tag))
        call to_history("d6",wave_par%d_sy,trim(wave_par%tag))
        call to_history("o6",wave_par%sy_0,trim(wave_par%tag))
      !}
      else
      !{
        call to_history("n3",wave_par%n_t,trim(wave_par%tag))
        call to_history("d3",wave_par%d_t,trim(wave_par%tag))
        call to_history("o3",wave_par%t_0,trim(wave_par%tag))
  
        call to_history("n4",wave_par%n_sx,trim(wave_par%tag))
        call to_history("d4",wave_par%d_sx,trim(wave_par%tag))
        call to_history("o4",wave_par%sx_0,trim(wave_par%tag))
  
        call to_history("n5",wave_par%n_sy,trim(wave_par%tag))
        call to_history("d5",wave_par%d_sy,trim(wave_par%tag))
        call to_history("o5",wave_par%sy_0,trim(wave_par%tag))
      !}
      end if

      if (gen_par%first_adj) then
      !{

        source_n_t=wave_par%n_t
        source_t_0=rev_extrap_par%t_0_first+wavelet_par%t_delay
        source_d_t=-wave_par%d_t

 write(0,*)'source_n_t=',source_n_t
 write(0,*)'source_d_t=',source_d_t
 write(0,*)'source_t_0=',source_t_0
  
        call to_history("esize",data_par%esize,trim(wave_par%tag_1))
        if(gen_par%tau_domain) then
          call to_history("n1",wave_par%n_tau,trim(wave_par%tag_1))
          call to_history("d1",wave_par%d_tau,trim(wave_par%tag_1))
          call to_history("o1",wave_par%tau_0,trim(wave_par%tag_1))
        else
          call to_history("n1",wave_par%n_z,trim(wave_par%tag_1))
          call to_history("d1",wave_par%d_z,trim(wave_par%tag_1))
          call to_history("o1",wave_par%z_0,trim(wave_par%tag_1))
        end if
        call to_history("n2",wave_par%n_off_x,trim(wave_par%tag_1))
        call to_history("d2",wave_par%d_off_x,trim(wave_par%tag_1))
        call to_history("o2",wave_par%off_x_0,trim(wave_par%tag_1))
  
        if(gen_par%n_data_dim >4) then 
          call to_history("n3",wave_par%n_off_y,trim(wave_par%tag_1))
          call to_history("d3",wave_par%d_off_y,trim(wave_par%tag_1))
          call to_history("o3",wave_par%off_y_0,trim(wave_par%tag_1))
    
          call to_history("n4",source_n_t,trim(wave_par%tag_1))
          call to_history("d4",source_d_t,trim(wave_par%tag_1))
          call to_history("o4",source_t_0,trim(wave_par%tag_1))
    
          call to_history("n5",wave_par%n_sx,trim(wave_par%tag_1))
          call to_history("d5",wave_par%d_sx,trim(wave_par%tag_1))
          call to_history("o5",wave_par%sx_0,trim(wave_par%tag_1))
    
          call to_history("n6",wave_par%n_sy,trim(wave_par%tag_1))
          call to_history("d6",wave_par%d_sy,trim(wave_par%tag_1))
          call to_history("o6",wave_par%sy_0,trim(wave_par%tag_1))
        else
          call to_history("n3",source_n_t,trim(wave_par%tag_1))
          call to_history("d3",source_d_t,trim(wave_par%tag_1))
          call to_history("o3",source_t_0,trim(wave_par%tag_1))
    
          call to_history("n4",wave_par%n_sx,trim(wave_par%tag_1))
          call to_history("d4",wave_par%d_sx,trim(wave_par%tag_1))
          call to_history("o4",wave_par%sx_0,trim(wave_par%tag_1))
    
          call to_history("n5",wave_par%n_sy,trim(wave_par%tag_1))
          call to_history("d5",wave_par%d_sy,trim(wave_par%tag_1))
          call to_history("o5",wave_par%sy_0,trim(wave_par%tag_1))
        end if
        
      !}
      end if
  
    end if if_comp_domain_wave_2

    !}
  end if
  if(read_wavefield) then
     !{
     if(write_wavefield) call seperr('Either read or write wavefield')
     wave_par%file=WAVE_INPUT

     call seperr('Read wavefiled not implemeted yet')

     if_comp_domain_wave_3 : if (gen_par%comp_domain(1:4) == 'midp') then

       if (auxinout(trim(wave_par%tag)) <= 0) then
          call seperr('Cannot find file Wavefield')
       end if
  
       call from_aux('Wavefield',"esize",esize)
  
       call from_aux('Wavefield',"n1",n1)
       call from_aux('Wavefield',"n2",n2)
       call from_aux('Wavefield',"n3",n3)
       call from_aux('Wavefield',"n4",n4)
       call from_aux('Wavefield',"n5",n5)
       call from_aux('Wavefield',"n6",n6)
  
       call from_aux('Wavefield',"d1",d1)
       call from_aux('Wavefield',"d2",d2)
       call from_aux('Wavefield',"d3",d3)
       call from_aux('Wavefield',"d4",d4)
       call from_aux('Wavefield',"d5",d5)
       call from_aux('Wavefield',"d6",d6)
  
       call from_aux('Wavefield',"o1",o1)
       call from_aux('Wavefield',"o2",o2)
       call from_aux('Wavefield',"o3",o3)
       call from_aux('Wavefield',"o4",o4)
       call from_aux('Wavefield',"o5",o5)
       call from_aux('Wavefield',"o6",o6)
  
       if(esize /= wave_par%esize ) call seperr('esize wrong in Wavefield')
       if(gen_par%tau_domain) then
         if(n1 /= wave_par%n_tau ) call seperr('n1 wrong in Wavefield')
         if(d1 /= wave_par%d_tau ) call seperr('d1 wrong in Wavefield')
         if(o1 /= wave_par%tau_0 ) call seperr('o1 wrong in Wavefield')
       else
         if(n1 /= wave_par%n_z ) call seperr('n1 wrong in Wavefield')
         if(d1 /= wave_par%d_z ) call seperr('d1 wrong in Wavefield')
         if(o1 /= wave_par%z_0 ) call seperr('o1 wrong in Wavefield')
       end if
  
       if(n2 /= wave_par%n_mx ) call seperr('n2 wrong in Wavefield')
       if(n3 /= wave_par%n_my ) call seperr('n3 wrong in Wavefield')
       if(n4 /= wave_par%n_hx ) call seperr('n4 wrong in Wavefield')
       if(n5 /= wave_par%n_hy ) call seperr('n5 wrong in Wavefield')
       if(n6 /= wave_par%n_t ) call seperr('n6 wrong in Wavefield')
  
       if(d2 /= wave_par%d_mx ) call seperr('d2 wrong in Wavefield')
       if(d3 /= wave_par%d_my ) call seperr('d3 wrong in Wavefield')
       if(d4 /= wave_par%d_hx) call seperr('d4 wrong in Wavefield')
       if(d5 /= wave_par%d_hy ) call seperr('d5 wrong in Wavefield')
       if(d6 /= wave_par%d_t ) call seperr('d6 wrong in Wavefield')
  
       if(o2 /= wave_par%mx_0 ) call seperr('o2 wrong in Wavefield')
       if(o3 /= wave_par%my_0 ) call seperr('o3 wrong in Wavefield')
       if(o4 /= wave_par%hx_0) call seperr('o4 wrong in Wavefield')
       if(o5 /= wave_par%hy_0 ) call seperr('o5 wrong in Wavefield')
       if(o6 /= wave_par%t_0 ) call seperr('o6 wrong in Wavefield')

     end if if_comp_domain_wave_3


     !}
  end if
  if(gen_par%debug1) write(0,*)'wavefield_file=',wave_par%file

  pi=acos(-1.)

  if(gen_par%tau_domain) then
    wave_par%ktau_0=0.
    wave_par%d_ktau=2.*pi/(wave_par%d_tau*FLOAT(wave_par%n_tau))
  else
    wave_par%kz_0=0.
    wave_par%d_kz=2.*pi/(wave_par%d_z*FLOAT(wave_par%n_z))
  end if

  wave_par%kmx_0=0.
  wave_par%kmy_0=0.
  wave_par%d_kmx=2.*pi/(wave_par%d_mx*FLOAT(wave_par%n_mx))
  wave_par%d_kmy=2.*pi/(wave_par%d_my*FLOAT(wave_par%n_my))

  if(gen_par%debug1) write(0,*)'wave_par-n_my=',wave_par%n_my
  if(gen_par%debug1) write(0,*)'wave_par-d_my=',wave_par%d_my
  if(gen_par%debug1) write(0,*)'wave_par-d_kmy=',wave_par%d_kmy

  if_comp_domain_wave_4 : if (gen_par%comp_domain(1:4) == 'midp') then
    wave_par%khx_0=0.
    wave_par%khy_0=0.
    wave_par%d_khx=2.*pi/(wave_par%d_hx*FLOAT(wave_par%n_hx))
    wave_par%d_khy=2.*pi/(wave_par%d_hy*FLOAT(wave_par%n_hy))
  end if if_comp_domain_wave_4

  return
end subroutine param_wave

subroutine param_slow(gen_par,wave_par,slow_par)
  use sep
  use genrev3d_types
  use wave_types
  use slow_types

  implicit none

  type (genrev3d_param_type) gen_par
  type (wave_param_type) wave_par
  type (slow_param_type) slow_par
  character(len=128) :: tag_name
  integer esize
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout

  ! slow parameters
  call from_param('tag_slow',slow_par%tag,'Slow')
  call from_param(trim(slow_par%tag),tag_name,'Slow not found')
  slow_par%tag=trim(slow_par%tag)

  slow_par%esize=4

  if_comp_domain_slow_1 : if (gen_par%comp_domain(1:4) == 'midp') then
    if((wave_par%n_hx /= 1) .or. (wave_par%n_hy /= 1) &
      ) then
       slow_par%n_comp=2
    else
       slow_par%n_comp=1 
    end if
  else if_comp_domain_slow_1
    slow_par%n_comp=1 
  end if if_comp_domain_slow_1
  

  if (auxin(trim(slow_par%tag)) .gt. 0) then
     !{
     slow_par%file=SLOW_INPUT
     call from_param('slowness',slow_par%slowness,.true.)
     call from_param('extrapolate_slow',slow_par%extrapolate_slow,.false.)
     call from_param('slow_scale',slow_par%scale,1.)

     call from_aux(trim(slow_par%tag),"esize",esize)

     if(esize /= slow_par%esize) call seperr('Slow must be real')

     if(gen_par%tau_domain) then
       call from_aux(trim(slow_par%tag),"n1",slow_par%n_tau,1)
       call from_aux(trim(slow_par%tag),"o1",slow_par%tau_0,0.)
       call from_aux(trim(slow_par%tag),"d1",slow_par%d_tau,1.)

       call to_history("From Slow: n1",slow_par%n_tau)
       call to_history("From Slow: o1",slow_par%tau_0)
       call to_history("From Slow: d1",slow_par%d_tau)

       if(wave_par%n_tau > slow_par%n_tau) call seperr('n1 in Slow < Wave')
       if(wave_par%tau_0 /= slow_par%tau_0) call seperr('o1 in Slow /= Wave')
       if(wave_par%d_tau /= slow_par%d_tau) call seperr('d1 in Slow /= Wave')
     else
       call from_aux(trim(slow_par%tag),"n1",slow_par%n_z,1)
       call from_aux(trim(slow_par%tag),"o1",slow_par%z_0,0.)
       call from_aux(trim(slow_par%tag),"d1",slow_par%d_z,1.)

       call to_history("From Slow: n1",slow_par%n_z)
       call to_history("From Slow: o1",slow_par%z_0)
       call to_history("From Slow: d1",slow_par%d_z)

       if(wave_par%n_z > slow_par%n_z) call seperr('n1 in Slow < Wave')
       if(wave_par%z_0 /= slow_par%z_0) call seperr('o1 in Slow /= Wave')
       if(wave_par%d_z /= slow_par%d_z) call seperr('d1 in Slow /= Wave')
     end if

     call from_aux(trim(slow_par%tag),"n2",slow_par%n_mx)
     call from_aux(trim(slow_par%tag),"o2",slow_par%mx_0)
     call from_aux(trim(slow_par%tag),"d2",slow_par%d_mx)

     call to_history("From Slow: n2",slow_par%n_mx)
     call to_history("From Slow: o2",slow_par%mx_0)
     call to_history("From Slow: d2",slow_par%d_mx)

!     if(wave_par%n_mx /= slow_par%n_mx) call seperr('n2 in Slow /= Wave')
!     if(wave_par%mx_0 /= slow_par%mx_0) call seperr('o2 in Slow /= Wave')
!     if(wave_par%d_mx /= slow_par%d_mx) call seperr('d2 in Slow /= Wave')

     call from_aux(trim(slow_par%tag),"n3",slow_par%n_my)
     call from_aux(trim(slow_par%tag),"o3",slow_par%my_0)
     call from_aux(trim(slow_par%tag),"d3",slow_par%d_my)

     call to_history("From Slow: n3",slow_par%n_my)
     call to_history("From Slow: o3",slow_par%my_0)
     call to_history("From Slow: d3",slow_par%d_my)

!     if(wave_par%n_my /= slow_par%n_my) call seperr('n3 in Slow /= Wave')
!     if(wave_par%my_0 /= slow_par%my_0) call seperr('o3 in Slow /= Wave')
!     if(wave_par%d_my /= slow_par%d_my) call seperr('d3 in Slow /= Wave')

     !}
   else   
     !}
     slow_par%file=SLOW_NO_FILE
     !}
   end if

   return
end subroutine param_slow

subroutine param_wavelet(gen_par,wavelet_par)
  use sep
  use genrev3d_types
  use wavelet_types

  implicit none

  type (genrev3d_param_type) gen_par
  type (wavelet_param_type) wavelet_par

  character(len=128) :: tag_name
  integer esize
  integer, external :: auxpar,getch,fetch,auxin,sreed,sseek,auxout

  if_comp_domain_wavelet_1 : if (gen_par%comp_domain(1:4) == 'shot') then
  ! wavelet parameters
    call from_param('tag_wavelet',wavelet_par%tag,'Wavelet')
    call from_param(trim(wavelet_par%tag),tag_name,'Wavelet not found')
    wavelet_par%tag=trim(wavelet_par%tag)
  
    wavelet_par%esize=4

    wavelet_par%file=WAVELET_INPUT

     call from_aux(trim(wavelet_par%tag),"n1",wavelet_par%n_t,1)
     call from_aux(trim(wavelet_par%tag),"o1",wavelet_par%t_0,0.)
     call from_aux(trim(wavelet_par%tag),"d1",wavelet_par%d_t,1.)

     call from_aux(trim(wavelet_par%tag),"n2",wavelet_par%n_off_x,1)
     call from_aux(trim(wavelet_par%tag),"o2",wavelet_par%off_x_0,0.)
     call from_aux(trim(wavelet_par%tag),"d2",wavelet_par%d_off_x,1.)

     call from_aux(trim(wavelet_par%tag),"n3",wavelet_par%n_off_y,1)
     call from_aux(trim(wavelet_par%tag),"o3",wavelet_par%off_y_0,0.)
     call from_aux(trim(wavelet_par%tag),"d3",wavelet_par%d_off_y,1.)

     call from_aux(trim(wavelet_par%tag),"tdelay",wavelet_par%t_delay,0.)

     call to_history("From Wavelet: n1",wavelet_par%n_t)
     call to_history("From Wavelet: o1",wavelet_par%t_0)
     call to_history("From Wavelet: d1",wavelet_par%d_t)

     call to_history("From Wavelet: n2",wavelet_par%n_off_x)
     call to_history("From Wavelet: o2",wavelet_par%off_x_0)
     call to_history("From Wavelet: d2",wavelet_par%d_off_x)

     call to_history("From Wavelet: n3",wavelet_par%n_off_y)
     call to_history("From Wavelet: o3",wavelet_par%off_y_0)
     call to_history("From Wavelet: d3",wavelet_par%d_off_y)

     call to_history("From Wavelet: tdelay",wavelet_par%t_delay)

  else if_comp_domain_wavelet_1
    wavelet_par%file=WAVELET_NO_FILE
  end if if_comp_domain_wavelet_1

  return
end subroutine param_wavelet
  


subroutine param_check(gen_par,data_par,wave_par,wavelet_par,slow_par, &
                       rev_extrap_par,image_par)
  use sep
  use genrev3d_types
  use data_types
  use wave_types
  use wavelet_types
  use slow_types
  use rev_extrap_types
  use image_types

  implicit none

  type (genrev3d_param_type) gen_par
  type (data_param_type) data_par
  type (wave_param_type) wave_par
  type (wavelet_param_type) wavelet_par
  type (slow_param_type) slow_par
  type (rev_extrap_param_type) rev_extrap_par
  type (image_param_type) image_par

  ! Check parameters

  !check that grids are congruent when comp_domain is shot
  if_comp_domain_check_1 : if (gen_par%comp_domain(1:4) == 'shot') then
    if (gen_par%first_adj) then
    !{
      if(wavelet_par%d_t /= rev_extrap_par%d_t_first) then
        write(0,*)'wavelet_par-d_t=',wavelet_par%d_t
        write(0,*)'rev_extrap_par-d_t=',rev_extrap_par%d_t_first
        call seperr("wavelet_par-d_t /= rev_extrap_par-d_t")
      end if
      if(image_par%d_t /= rev_extrap_par%d_t_first) then
        write(0,*)'image_par-d_t=',image_par%d_t
        write(0,*)'rev_extrap_par-d_t=',rev_extrap_par%d_t_first
        call seperr("image_par-d_t /= rev_extrap_par-d_t")
      end if
      if(amod(image_par%t_0,image_par%d_t) /= 0. ) then
        write(0,*)'image_par-t_0=',image_par%t_0
        write(0,*)'image_par-d_t=',image_par%d_t
        write(0,*) 'mod=',amod(image_par%t_0,image_par%d_t)
!        call seperr("image_par-t_0 not multiple of image_par-d_t")
      end if
      if(image_par%n_t_lag /= 1) then
        if(image_par%d_t /= image_par%d_t_lag) then
          write(0,*)'image_par-d_t=',image_par%d_t
          write(0,*)'image_par-d_t_lag=',image_par%d_t_lag
          call seperr("image_par-d_t /= image_par-d_t_lag")
        end if
      end if

      if(wave_par%d_mx /= image_par%d_mx) then
        write(0,*)'wave_par-d_mx=',wave_par%d_mx
        write(0,*)'image_par-d_mx=',image_par%d_mx
        call seperr("wave-d_mx /=  image-d_mx")
      end if
    !}
    else
    !{
      if(wavelet_par%d_t /= rev_extrap_par%d_t_second) then
        write(0,*)'wavelet_par-d_t=',wavelet_par%d_t
        write(0,*)'rev_extrap_par-d_t=',rev_extrap_par%d_t_second
        call seperr("wavelet_par-d_t /= rev_extrap_par-d_t")
      end if
    !}
    end if

!    if(amod(wave_par%d_sx,wave_par%d_mx) /= 0) then
!      write(0,*)'wave_par-d_sx=',wave_par%d_sx
!      write(0,*)'wave_par-d_mx=',wave_par%d_mx
!      call seperr("d_sx not multiple of d_mx")
!    end if

    if(wave_par%off_x_0 >0) then
      write(0,*)'wave_par-off_x_0=',wave_par%off_x_0
      call seperr("off_x_0 >0")
    end if

    if(mod(wave_par%off_x_0,wave_par%d_mx) /= 0) then
      write(0,*)'wave_par-off_x_0=',wave_par%off_x_0
      write(0,*)'wave_par-d_mx=',wave_par%d_mx
      call seperr("off_x_0_pad not multiple of d_mx")
    end if
    if(mod(data_par%off_x_0,data_par%d_mx) /= 0) then
      write(0,*)'data_par-off_x_0=',data_par%off_x_0
      write(0,*)'wave_par-d_mx=',wave_par%d_mx
      call seperr("off_x_0 not multiple of d_mx")
    end if
    if(wave_par%off_x_0 > data_par%off_x_0) then
      write(0,*)'wave_par-off_x_0=',wave_par%off_x_0
      write(0,*)'data_par-off_x_0=',data_par%off_x_0
      call seperr("off_x_0_pad > off_x_0")
    end if

    if(.not. gen_par%image_zero_offset) then
      if(wave_par%d_mx /= image_par%d_hx) then
        write(0,*)'wave_par-d_mx=',wave_par%d_mx
        write(0,*)'image_par-d_hx=',image_par%d_hx
        call seperr("d_mx /=  d_hx")
      end if
    end if

    if(wave_par%n_my /= 1) then
    !{
      if(amod(wave_par%d_sy,wave_par%d_my) /= 0) then
        write(0,*)'wave_par-d_sy=',wave_par%d_sy
        write(0,*)'wave_par-d_my=',wave_par%d_my
        call seperr("d_sy not multiple of d_my")
      end if
      if(wave_par%off_y_0 >0) then
        write(0,*)'wave_par-off_y_0=',wave_par%off_y_0
        call seperr("off_y_0 >0")
      end if
      if(mod(wave_par%off_y_0,wave_par%d_my) /= 0) then
        write(0,*)'wave_par-d_my=',wave_par%d_my
        write(0,*)'wave_par-off_y_0=',wave_par%off_y_0
        call seperr("off_y_0_pad not multiple of d_my")
      end if
      if(mod(data_par%off_y_0,data_par%d_my) /= 0) then
        write(0,*)'data_par-off_y_0=',data_par%off_y_0
        write(0,*)'wave_par-d_my=',wave_par%d_my
        call seperr("off_y_0 not multiple of d_my")
      end if
      if(wave_par%off_y_0 > data_par%off_y_0) then
        write(0,*)'wave_par-off_y_0=',wave_par%off_y_0
        write(0,*)'data_par-off_y_0=',data_par%off_y_0
        call seperr("off_y_0_pad > off_y_0")
      end if
      if(wave_par%d_my /= image_par%d_my) then
        write(0,*)'wave_par-d_my=',wave_par%d_my
        write(0,*)'image_par-d_my=',image_par%d_my
        call seperr("d_my /=  d_my")
      end if

      if(.not. gen_par%image_zero_offset) then
        if(wave_par%d_my /= image_par%d_hy) then
          write(0,*)'wave_par-d_my=',wave_par%d_my
          write(0,*)'image_par-d_hy=',image_par%d_hy
          call seperr("d_my /= d_hy")
        end if
      end if

    !}
    end if

  else if_comp_domain_check_1 

    if(gen_par%tau_domain) then
      if(wave_par%n_tau < image_par%n_tau) then
        write(0,*)'wave_par-n_tau=',wave_par%n_tau
        write(0,*)'image_par-n_tau=',image_par%n_tau
        call seperr("wave-n_tau <  image-n_tau")
      end if
    else
      if(wave_par%n_z < image_par%n_z) then
        write(0,*)'wave_par-n_z=',wave_par%n_z
        write(0,*)'image_par-n_z=',image_par%n_z
        call seperr("wave-n_z <  image-n_z")
      end if
    end if

  end if if_comp_domain_check_1

  if(gen_par%image_zero_offset .and. image_par%write_image_hz) then
     call seperr("image_zero_offset unconsinstent with write_image_hz")
  end if

  if(gen_par%surf_offset_cig .and.  &
     ((.not. image_par%image_memory) .or. &
      (.not. gen_par%image_zero_offset) &
     ) &
    ) then
     call seperr("surf_offset_cig only with image_zero_offset and not image_memory")
  end if


  ! check consinstency
  select case (gen_par%domain_range(1:9))
  case ('data_imag')
  case ('data_wave')
  case default
     write(0,*)'gen_par-domain_range=',trim(gen_par%domain_range)
     call seperr('Not supported domain_range')
  end select

  select case (gen_par%oper_type(1:2))
  case ('co')
     gen_par%oper_type(1:10)='const_slow'
     if (slow_par%file /= SLOW_NO_FILE) then
        write(0,*)'WARNING: Does not need a Slow file'
        !      call seperr('Does not need a Slow file')
     end if
     if (wave_par%file == WAVE_INPUT) then
        call seperr('It should not try to read Wavefield file')
     end if
  case ('fu')
  case default
     write(0,*)'gen_par-oper_type=',trim(gen_par%oper_type)
     call seperr('Not supported oper_type')
  end select

  return
end subroutine param_check
