module rev_extrap_types
  type rev_extrap_param_type 

! add, adj - add or adjoint
! wave_step - step that output wavefield
! wave_tmp_step - step that output temporary wavefield
! wave_sou_step - step that output source wavefield
! image_step - step that output image
! data_step - step that output data

     logical adj,add
     logical wave_step,wave_tmp_step,wave_sou_step
     logical image_step,data_step

! n_threads - number of threads
! n_t_first - number of time steps of first extrapolation loop
! n_t_second - number of time steps of second extrapolation loop
! i_sx - inline index of shot being modeled/migrated
! i_sy - crossline index of shot being modeled/migrated
! i_t_extrap - time index of extrapolation step

     integer n_threads,n_t_first,n_t_second,i_sx,i_sy,i_t_extrap

! t_0_first - time of first time step (first extrapolation)
! t_0_second - time of first time step (second extrapolation)
! d_t_first - time sampling (first extrapolation)
! d_t_second - time sampling (second extrapolation)
! d_t - time sampling 
! t - time  during extrapolation 
     real t_0_first,t_0_second,d_t_first,d_t_second,d_t,t

  end type rev_extrap_param_type
end module rev_extrap_types

