module wave_types

  integer, parameter ::  WAVE_SYNTH=-2
  integer, parameter ::  WAVE_INPUT=-1
  integer, parameter ::  WAVE_OUTPUT=1
  integer, parameter ::  WAVE_NO_FILE=0

  type wave_param_type 
     character(len=128) tag,tag_1,tag_2
     integer esize
     integer file
     integer n_t,n_t_step
     integer n_z,n_tau
     integer n_hx,n_hy,n_mx,n_my
     integer n_off_x,n_off_y,n_sx,n_sy

     real d_t,d_z,d_tau
     real d_hx,d_hy,d_mx,d_my,d_kz,d_ktau,d_khx,d_khy,d_kmx,d_kmy
     real d_off_x,d_off_y,d_sx,d_sy
     real t_0,z_0,tau_0
     real hx_0,hy_0,mx_0,my_0,kz_0,ktau_0,khx_0,khy_0,kmx_0,kmy_0
     real off_x_0,off_y_0,sx_0,sy_0,sx,sy

     integer, pointer, dimension (:)   :: i_t_step

  end type wave_param_type

end module wave_types

