module gendown3d_types

  integer, parameter ::  status_init=0
  integer, parameter ::  mem_fixed_init=0
  integer, parameter ::  mem_n_w_inp_init=0
  integer, parameter ::  mem_n_mx_inp_init=0
  integer, parameter ::  mem_n_my_inp_init=0
  integer, parameter ::  mem_n_hx_inp_init=0
  integer, parameter ::  mem_n_hy_inp_init=0

  type gendown3d_info_type
     integer :: status
     integer :: mem_fixed
     integer :: mem_n_w_inp
     integer :: mem_n_mx_inp,mem_my_inp
     integer :: mem_n_hx_inp,mem_hy_inp
  end type  gendown3d_info_type

  type(gendown3d_info_type), parameter :: info_default = gendown3d_info_type &
  (status_init, &
  mem_fixed_init, &
  mem_n_w_inp_init, &
  mem_n_mx_inp_init, &
  mem_n_my_inp_init, &
  mem_n_hx_inp_init, &
  mem_n_hy_inp_init )

  logical, parameter :: verb_init=.true.
  logical, parameter :: debug1_init=.false.
  logical, parameter :: debug2_init=.false.
  logical, parameter :: timers_on_init=.false.
  logical, parameter :: rho_filt_init=.false.
  logical, parameter :: image_zero_offset_init=.true.
  logical, parameter :: image_cig_init=.false.
  logical, parameter :: k_domain_init=.true.
  logical, parameter :: first_adj_init=.false.
  logical, parameter :: first_add_init=.false.
  logical, parameter :: check_stability_init=.false.
  logical, parameter :: complex_image_init=.false.
  logical, parameter :: synth_data_init=.false.
  logical, parameter :: no_data_init=.false.
  logical, parameter :: single_hx_dip_init=.false.
  logical, parameter :: time_mig_init=.false.

  ! choices 'cons-slow' 'back_slow' 'full_slow' 'pert_slow'
  character(len=128), parameter :: oper_type_init='full_slow'
  character(len=128), parameter :: domain_range_init='slow_ima'
  character(len=128), parameter :: cig_forw_transf_init='pull'
  character(len=128), parameter :: amp_weights_init='none'

  integer, parameter :: n_threads_init=-1
  integer, parameter :: max_memory_init=134217728
  integer, parameter :: non_data_memory_init=0

  integer, parameter :: n_data_dim_init=4
  integer, parameter :: n_mx_pad_init=-huge(1)/10.
  integer, parameter :: n_my_pad_init=-huge(1)/10.
  integer, parameter :: n_hx_pad_init=-huge(1)/10.
  integer, parameter :: n_hy_pad_init=-huge(1)/10.
  integer, parameter :: n_z_image_init=-1

  integer, parameter :: n_w_block_init=-1
  integer, parameter :: n_z_block_init=-1
  integer, parameter :: i_block_z_restart_init=-1

  integer, parameter :: i_hx_0_shift_start_init=1
  integer, parameter :: n_hx_0_shift_period_init=1

  real, parameter :: slow_const_init=-1.
  real, parameter :: slow_const_image_init=-1.
  real, parameter :: slow_const_image_z0_init=-1.
  real, parameter :: slow_scale_init=1.
  real, parameter :: stat_shift_init=0.
  real, parameter :: max_propag_angle_init=89.
  real, parameter :: z_image_0_init=-1.
  real, parameter :: d_z_image_init=-1.
  real, parameter :: t_spike_0_init=-1.
  real, parameter :: mx_spike_0_init=huge(1.)/10.
  real, parameter :: my_spike_0_init=huge(1.)/10.
  real, parameter :: hx_spike_0_init=huge(1.)/10.
  real, parameter :: hy_spike_0_init=huge(1.)/10.
  real, parameter :: t_spike_1_init=-1.
  real, parameter :: mx_spike_1_init=huge(1.)/10.
  real, parameter :: my_spike_1_init=huge(1.)/10.
  real, parameter :: hx_spike_1_init=huge(1.)/10.
  real, parameter :: hy_spike_1_init=huge(1.)/10.
  real, parameter :: px_plane_0_init=0.
  real, parameter :: py_plane_0_init=0.
  real, parameter :: px_plane_1_init=0.
  real, parameter :: py_plane_1_init=0.

  real, parameter :: freq_min_0_init=-1.
  real, parameter :: freq_min_1_init=-1.
  real, parameter :: freq_max_0_init=-1.
  real, parameter :: freq_max_1_init=-1.

  real, parameter :: hx_0_shift_init=0

  type gendown3d_param_type
     logical :: verb
     logical :: debug1
     logical :: debug2
     logical :: timers_on
     logical :: rho_filt
     logical :: image_zero_offset
     logical :: image_cig
     logical :: k_domain
     logical :: first_adj
     logical :: first_add
     logical :: check_stability
     logical :: complex_image
     logical :: synth_data
     logical :: no_data
     logical :: single_hx_dip
     logical :: time_mig

     character(len=128) :: oper_type
     character(len=128) :: domain_range
     character(len=128) :: cig_forw_transf
     character(len=128) :: amp_weights

     integer :: n_threads
     integer :: max_memory
     integer :: non_data_memory

     integer :: n_data_dim
     integer :: n_mx_pad
     integer :: n_my_pad
     integer :: n_hx_pad
     integer :: n_hy_pad
     integer :: n_z_image

     integer :: n_w_block
     integer :: n_z_block

     integer :: i_block_z_restart
     integer :: i_hx_0_shift_start
     integer :: n_hx_0_shift_period

     real :: slow_const
     real :: slow_const_image
     real :: slow_const_image_z0
     real :: slow_scale
     real :: stat_shift
     real :: max_propag_angle
     real :: z_image_0
     real :: d_z_image
     real :: t_spike_0
     real :: mx_spike_0
     real :: my_spike_0
     real :: hx_spike_0
     real :: hy_spike_0
     real :: t_spike_1
     real :: mx_spike_1
     real :: my_spike_1
     real :: hx_spike_1
     real :: hy_spike_1
     real :: px_plane_0
     real :: py_plane_0
     real :: px_plane_1
     real :: py_plane_1

     real :: freq_min_0
     real :: freq_min_1
     real :: freq_max_0
     real :: freq_max_1
     real :: hx_0_shift

  end type  gendown3d_param_type
end module gendown3d_types
